﻿package n2
{
	// SYSTEM PACKAGE
	import flash.display.*;
	import flash.events.*;
	import flash.ui.Keyboard;
	
	/**
	/* @func	： 操作系基本クラス
	/* @author	： N2
	/* @date	： 2009/05/25 N2 作成
	**/
	public class N2ListenerBase
	{
		// 操作系設置対象オブジェクト
		protected var target:*;
		
		// イベントリスナ状態
		protected var stat:Object;
		
		// イベントリスナIDテーブル
		protected const LISTENER_ID_TABLE:Array = [
			MouseEvent.CLICK,
			MouseEvent.DOUBLE_CLICK,
			MouseEvent.MOUSE_DOWN,
			MouseEvent.MOUSE_MOVE,
			MouseEvent.MOUSE_OUT,
			MouseEvent.MOUSE_OVER,
			MouseEvent.MOUSE_UP,
			MouseEvent.MOUSE_WHEEL,
			MouseEvent.ROLL_OUT,
			MouseEvent.ROLL_OVER,
			KeyboardEvent.KEY_DOWN,
			KeyboardEvent.KEY_UP,
			Event.COMPLETE,
			Event.EXIT_FRAME,
			Event.SOUND_COMPLETE,
			TimerEvent.TIMER
		];
		
		// イベントリスナテーブル
		protected const LISTENER_TABLE:Array = [
			ListenerClick,
			ListenerDoubleClick,
			ListenerMouseDown,
			ListenerMouseMove,
			ListenerMouseOut,
			ListenerMouseOver,
			ListenerMouseUp,
			ListenerMouseWheel,
			ListenerMouseRollOut,
			ListenerMouseRollOver,
			ListenerKeyboardKeyDown,
			ListenerKeyboardKeyUp,
			ListenerComplete,
			ListenerExitFrame,
			ListenerSoundComplete,
			ListenerTimer
		];
		
		/**
		/*	@brief	: コンストラクタ
		/* 
		/*	@li		: 
		/*	@param	: *	:	target	:	操作系設置対象オブジェクト
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		public function N2ListenerBase(target:*) 
		{
			// イベントリスナ状態オブジェクトを初期化
			this.stat = new Object();
			
			// 操作系設置対象オブジェクトを取得
			this.target = target;
		}
		
		/**
		/*	@brief	: 全てのイベントリスナを削除
		/* 
		/*	@li		: 
		/*	@param	: 
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		public function DelAllListener() : void
		{
			// 全てのイベントリスナを削除
			for each (var evt_id:* in this.stat) {
				this.DelListener(evt_id);
			}
		}
		
		/**
		/*	@brief	: 指定のイベントリスナを設置
		/* 
		/*	@li		: 
		/*	@param	: *	:	evt_id	:	イベントID
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		public function SetListener(evt_id:*) : void
		{
			// 指定のイベントリスナを設置
			if (!this.target.hasEventListener(evt_id)) {
				this.stat[evt_id] = evt_id;
				this.target.addEventListener(evt_id, this.LISTENER_TABLE[this.LISTENER_ID_TABLE.indexOf(evt_id)]);
			}
		}
		
		/**
		/*	@brief	: 指定のイベントリスナを削除
		/* 
		/*	@li		: 
		/*	@param	: *	:	evt_id	:	イベントID
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		public function DelListener(evt_id:*) : void
		{
			// 指定のイベントリスナを削除
			if (this.target.hasEventListener(evt_id)) {
				delete this.stat[evt_id];
				this.target.removeEventListener(evt_id, this.LISTENER_TABLE[this.LISTENER_ID_TABLE.indexOf(evt_id)]);
			}
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: CLICK
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerClick(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: DOUBLE_CLICK
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerDoubleClick(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_DOWN
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseDown(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_MOVE
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseMove(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_OUT
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseOut(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_OVER
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseOver(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_UP
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseUp(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_WHEEL
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseWheel(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_ROLL_OUT
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseRollOut(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: MOUSE_ROLL_OVER
		/*	@param	: MouseEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerMouseRollOver(evt:MouseEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(このメソッド自体は継承しない)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		private function ListenerKeyboardKeyDown(evt:KeyboardEvent) : void
		{
			// 押されたｷｰコードに対応するリスナを呼び出す
			switch (evt.keyCode) {
			case Keyboard.UP:
				ListenerKeyboardKeyDownUp(evt);
				break;
			case Keyboard.DOWN:
				ListenerKeyboardKeyDownDown(evt);
				break;
			case Keyboard.LEFT:
				ListenerKeyboardKeyDownLeft(evt);
				break;
			case Keyboard.RIGHT:
				ListenerKeyboardKeyDownRight(evt);
				break;
			case Keyboard.SPACE:
				ListenerKeyboardKeyDownSpace(evt);
				break;
			case Keyboard.ENTER:
				ListenerKeyboardKeyDownEnter(evt);
				break;
			}
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(UP)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyDownUp(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(Down)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyDownDown(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(LEFT)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyDownLeft(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(RIGHT)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyDownRight(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(SPACE)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/17 N2 作成
		**/
		protected function ListenerKeyboardKeyDownSpace(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(ENTER)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/21 N2 作成
		**/
		protected function ListenerKeyboardKeyDownEnter(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_UP(このメソッド自体は継承しない)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		private function ListenerKeyboardKeyUp(evt:KeyboardEvent) : void
		{
			// 押されたｷｰコードに対応するリスナを呼び出す
			switch (evt.keyCode) {
			case Keyboard.UP:
				ListenerKeyboardKeyUpUp(evt);
				break;
			case Keyboard.DOWN:
				ListenerKeyboardKeyUpDown(evt);
				break;
			case Keyboard.LEFT:
				ListenerKeyboardKeyUpLeft(evt);
				break;
			case Keyboard.RIGHT:
				ListenerKeyboardKeyUpRight(evt);
				break;
			case Keyboard.SPACE:
				ListenerKeyboardKeyUpSpace(evt);
				break;
			case Keyboard.ENTER:
				ListenerKeyboardKeyUpEnter(evt);
				break;
			}
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(UP)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyUpUp(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(Down)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyUpDown(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(LEFT)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyUpLeft(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(RIGHT)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/12 N2 作成
		**/
		protected function ListenerKeyboardKeyUpRight(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(SPACE)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/17 N2 作成
		**/
		protected function ListenerKeyboardKeyUpSpace(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: KEY_DOWN(ENTER)
		/*	@param	: KeyboardEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/21 N2 作成
		**/
		protected function ListenerKeyboardKeyUpEnter(evt:KeyboardEvent) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: COMPLETE
		/*	@param	: Event	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerComplete(evt:Event) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: EXIT_FRAME
		/*	@param	: Event	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/05/25 N2 作成
		**/
		protected function ListenerExitFrame(evt:Event) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: SOUND_COMPLETE
		/*	@param	: Event	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/20 N2 作成
		**/
		protected function ListenerSoundComplete(evt:Event) : void
		{
		}
		
		/**
		/*	@brief	: イベントリスナ
		/* 
		/*	@li		: TIMER
		/*	@param	: TimerEvent	:	evt	:	イベント情報
		/*	@return	: 
		/*	@author	: N2
		/*	@note	:
		/*	@date	: 2009/06/04 N2 作成
		**/
		protected function ListenerTimer(evt:TimerEvent) : void
		{
		}
	}
}